import type * as DS from '../shared';
import { Aesthetic, Datum } from './Aesthetic';
import { Scatterplot } from '../scatterplot';
import type { TextureSet } from './AestheticSet';
declare abstract class BooleanAesthetic<ChannelType extends DS.OpChannel<number | DS.IsoDateString> | DS.ConstantChannel<boolean> | DS.LambdaChannel<DS.JSValue, string | number | boolean>, Input extends DS.InType> extends Aesthetic<ChannelType, Input, DS.BoolOut> {
    protected _func: ((d: Input['domainType']) => boolean);
    constructor(encoding: ChannelType | null, scatterplot: Scatterplot, aesthetic_map: TextureSet, id: string);
    toGLType(a: boolean): 0 | 1;
    convertOpDatesToNumbers(channel: DS.OpChannel<DS.IsoDateString | number>): [number, number];
    ops_to_array(): [number, number, number];
    apply(point: Datum): boolean;
    apply_op(point: Datum): boolean;
    get default_domain(): [number, number];
}
/**
 * "Foreground" defines whether a field should be
 * plotted in the front of the screen: by default
 * background points will be plotted with much less resolution.
 */
export declare class Foreground<ChannelType extends DS.BooleanChannel = DS.BooleanChannel, Input extends DS.InType = DS.InType> extends BooleanAesthetic<ChannelType, Input> {
    default_constant: boolean;
    default_range: [false, true];
    get active(): boolean;
}
export declare class Filter<ChannelType extends DS.BooleanChannel = DS.BooleanChannel, Input extends DS.InType = DS.InType> extends BooleanAesthetic<ChannelType, Input> {
    default_constant: boolean;
    default_range: [false, true];
}
export {};
//# sourceMappingURL=BooleanAesthetic.d.ts.map