import type * as DS from '../shared';
import { ScaledAesthetic } from './ScaledAesthetic';
import { Scatterplot } from '../scatterplot';
import { TextureSet } from './AestheticSet';
import { Datum } from './Aesthetic';
export declare class Color<ChannelType extends DS.ColorScaleChannel = DS.ColorScaleChannel, Input extends DS.NumberIn | DS.DateIn | DS.CategoryIn = DS.NumberIn | DS.DateIn | DS.CategoryIn> extends ScaledAesthetic<ChannelType, Input, DS.ColorOut> {
    protected _func?: (d: Input['domainType']) => string;
    _texture_buffer: Uint8Array | null;
    texture_type: string;
    default_constant: string;
    default_transform: DS.Transform;
    constructor(encoding: ChannelType | null, scatterplot: Scatterplot, map: TextureSet, id: string);
    get default_range(): [string, string];
    protected categoricalRange(): string[];
    post_to_regl_buffer(): void;
    default_data(): Uint8Array;
    get use_map_on_regl(): 1;
    get colorscheme_size(): number;
    apply(v: Datum): string;
    toGLType(color: string): [number, number, number];
    encode_for_textures(range: string | [string, string] | string[]): void;
}
//# sourceMappingURL=ColorAesthetic.d.ts.map