import { ScaleLinear } from 'd3-scale';
import type { Renderer } from './rendering';
import { StructRowProxy } from 'apache-arrow';
import { Rectangle } from './tile';
import type { Dataset } from './Dataset';
import type * as DS from './shared';
import type { Scatterplot } from './scatterplot';
type Annotation = {
    x: number;
    y: number;
    dx: number;
    dy: number;
    data: StructRowProxy;
};
export declare class Zoom {
    prefs: DS.APICall;
    svg_element_selection: d3.Selection<d3.ContainerElement, Record<string, any>, any, any>;
    width: number;
    height: number;
    renderers: Map<string, Renderer>;
    tileSet?: Dataset;
    _timer?: d3.Timer;
    _scales?: Record<string, d3.ScaleLinear<number, number>>;
    zoomer?: d3.ZoomBehavior<Element, unknown>;
    transform?: d3.ZoomTransform;
    _start?: number;
    scatterplot: Scatterplot;
    private stopTimerAt?;
    constructor(selector: string, prefs: DS.APICall, plot: Scatterplot);
    attach_tiles(tiles: Dataset): this;
    attach_renderer(key: string, renderer: Renderer): this;
    zoom_to(k: number, x: number, y: number, duration?: number): void;
    html_annotation(points: Annotation[]): void;
    zoom_to_bbox(corners: Rectangle, duration?: number, buffer?: number): void;
    initialize_zoom(): void;
    set_highlit_points(data: StructRowProxy[]): void;
    set_highlit_point(point: StructRowProxy): void;
    add_mouseover(): void;
    current_corners(): Rectangle | undefined;
    current_center(): number[];
    restart_timer(run_at_least?: number): import("d3-timer").Timer;
    data(dataset: undefined): Dataset;
    data(dataset: Dataset): Zoom;
    scales(): Record<string, ScaleLinear<number, number>>;
    webgl_scale(flatten?: boolean): number[];
    tick(force?: boolean): void;
}
export declare function window_transform(x_scale: ScaleLinear<number, number, never>, y_scale: ScaleLinear<number, number, never>): number[][];
export {};
//# sourceMappingURL=interaction.d.ts.map